// @flow
import type { 
  VUE_INSTANCE,
  COMPONENT_OBJECT_OPTION
 } from './type'

// 将props指向vue父组件实例
export default function (vueInstance: VUE_INSTANCE, option: COMPONENT_OBJECT_OPTION): void {
    if (option.on || !option.method) return
    const METHODS = Object.assign({}, option.method)
    option.on = {}
    Object.keys(METHODS).forEach(key => option.on &&
    Reflect.set(option.on, key, vueInstance[METHODS[key]])
    )
}