// @flow
import type { CONSTRUCTOR_OPTION } from './type'
import getProps from './props'
import getMethods from './methods'
import getContainerStyle from './style'
import defineInstanceProperty from './properties'
// 生成vue render方法
export default function (option: CONSTRUCTOR_OPTION): Function {
  const components = option.component
  return function (createElement: Function) {
    const vueInstanceSelf = this // this指向vue实例
    defineInstanceProperty(vueInstanceSelf)
    if (!Array.isArray(components)) {
      // 若只有一个组件
      // 遍历以转换格式为vue组件配置格式
      getProps(vueInstanceSelf, option)
      getMethods(vueInstanceSelf, option)
      return createElement(components.components, components.option)
    }
    return createElement('div', getContainerStyle(option.style), components.map(({ components, option }) => {
      if (option) {
        getProps(vueInstanceSelf, option)
        getMethods(vueInstanceSelf, option)
        return createElement(components, option) // 若存在组件配置
      } else return createElement(components) // 不存在组件配置
    }))
  }
}